#include "CloseState.h"
#include "OpenState.h"
#include "RunState.h"
#include "Context.h"
#include <iostream>

State * CloseState::closeState = NULL;

CloseState::~CloseState() {
    delete closeState;
}

// return an instance of CLOSE state
State* CloseState::instance() {
    if (closeState) return closeState;
    closeState = new CloseState();
    return closeState;
}

// transit state to OPEN
void CloseState::open() {
    std::cout << "The current state is CLOSE, ";
    this -> context -> changeState(OpenState::instance());
    this -> context -> getState() -> open();
}

void CloseState::close() {
    std::cout << "now transits to CLOSE!" << std::endl;
}

// transit state to run
void CloseState::run() {
    std::cout << "The current state is CLOSE, ";
    this -> context -> changeState(RunState::instance());
    this -> context -> getState() -> run();
}

// invalid operation
void CloseState::stop() {
    std::cout << "To STOP the elevator, please transit to RUN first!" << std::endl;
}