#include "Context.h"
#include "StopState.h"
#include <iostream>

Context::Context() {
    changeState(StopState::instance()); // initail state is STOP
}

Context::~Context() {

}

// change the current state, and bind the context itself to the new state
void Context::changeState(State *state) {
    this -> state = state;
    this -> state -> setContext(this);
}

// return the current state
State* Context::getState() {
    return this -> state;
}

// open the elevator
void Context::open() {
    state -> open();
}

// close the elevator
void Context::close() {
    state -> close();
}

// run the elevator
void Context::run() {
    state -> run();
}

// stop the elevator
void Context::stop() {
    state -> stop();
}

int main() {
    Context *context = new Context(); // initail state of elevator is STOP
    context -> open();
    context -> close();
    context -> run();
    context -> stop();
    context -> open();
    context -> close();
    context -> run();
    context -> stop();

    delete context;
    return 0;
}