/////////////////////////////////////////////////////////////////////
// Context.h                                                       //
// ver 1.0                                                         //
// Yuan Liu, Demo program for CSE 776, Fall 2018                   //
/////////////////////////////////////////////////////////////////////
/*
*  File Operations:
*  -------------------
*  - This file defines a simple demo of the state pattern.
*    you can choose an operation among RUN, STOP, CLOSE, 
*    and OPEN, and use an instance of Context to apply it.
*
*
*  Maintenance History:
*  --------------------
*  ver 1.0 : 18 Sep 2018
*  - first release
*/
#pragma once
#include "State.h"

class Context {
public:
    Context();
    ~Context();
    void changeState(State *state); // change the current state
    State* getState();              // return the current state
    void open();                    // open the elevator
    void close();                   // close the elevator
    void run();                     // run the elevator
    void stop();                    // stop the elevator

private:
    State *state;
};