#include "OpenState.h"
#include "CloseState.h"
#include "Context.h"
#include <iostream>

State * OpenState::openState = NULL;

OpenState::~OpenState() {
    delete openState;
}

// return an instance of OPEN state
State* OpenState::instance() {
    if (openState) return openState;
    openState = new OpenState();
    return openState;
}

void OpenState::open() {
    std::cout << "now transits to OPEN!" << std::endl;
}

// transit state to CLOSE
void OpenState::close() {
    std::cout << "The current state is OPEN, ";
    this -> context -> changeState(CloseState::instance());
    this -> context -> getState() -> close();
}

// invalid operation
void OpenState::run() {
    std::cout << "To RUN the elevator, please transit to CLOSE first!" << std::endl;
}

// invalid operation
void OpenState::stop() {
    std::cout << "To STOP the elevator, please transit to RUN first!" << std::endl;
}