#include "RunState.h"
#include "StopState.h"
#include "Context.h"
#include <iostream>

State * RunState::runState = NULL;

RunState::~RunState() {
    delete runState;
}

// return an instance of RUN state
State* RunState::instance() {
    if (runState) return runState;
    runState = new RunState();
    return runState;
}

// invalid operation
void RunState::open() {
    std::cout << "To OPEN the elevator, please transit to STOP first!" << std::endl;
}

// invalid operation
void RunState::close() {
    std::cout << "To CLOSE the elevator, please transit to OPEN first!" << std::endl;
}

void RunState::run() {
    std::cout << "now transits to RUN!" << std::endl;
}

// transit state to RUN
void RunState::stop() {
    std::cout << "The current state is RUN, ";
    this -> context -> changeState(StopState::instance());
    this -> context -> getState() -> stop();
}