#include "StopState.h"
#include "OpenState.h"
#include "Context.h"
#include <iostream>

State * StopState::stopState = NULL;

StopState::~StopState() {
    delete stopState;
}

// return an instance of STOP state
State* StopState::instance() {
    if (stopState) return stopState;
    stopState = new StopState();
    return stopState;
}

// transit state to OPEN
void StopState::open() {
    std::cout << "The current state is STOP, ";
    this -> State::context -> changeState(OpenState::instance());
    this -> State::context -> getState() -> open();
}

// invalid operation
void StopState::close() {
    std::cout << "To CLOSE the elevator, please transit to OPEN first!" << std::endl;
}

// invalid operation
void StopState::run() {
    std::cout << "To RUN the elevator, please transit to CLOSE first!" << std::endl;
}

void StopState::stop() {
    std::cout << "now transits to STOP!" << std::endl;
}