#include "Context.h"

OpenState* Context::openState = NULL;
CloseState* Context::closeState = NULL;
RunState* Context::runState = NULL;
StopState* Context::stopState = NULL;

Context::Context() {
    openState = new OpenState();
    closeState = new CloseState();
    runState = new RunState();
    stopState = new StopState();
    state = stopState;              // initail state is STOP
    currentState = "STOP";

    stateMap["STOP"]["OPEN"] = true;
    stateMap["OPEN"]["CLOSE"] = true;
    stateMap["CLOSE"]["OPEN"] = true;
    stateMap["CLOSE"]["RUN"] = true;
    stateMap["RUN"]["STOP"] = true;
}

Context::~Context() {
    delete openState;
    delete closeState;
    delete runState;
    delete stopState;
    openState = NULL;
    closeState = NULL;
    runState = NULL;
    stopState = NULL;
}

// if valid, transit state to OPEN, otherwise, print a warning message
void Context::open() {
    std::cout << "The current state is " << currentState << ", ";
    if (stateMap[currentState]["OPEN"]) {
        currentState = "OPEN";
        state = openState;
        state -> open();
    }
    else std::cout << "this is not a valid operation, please refer to the state graph!" << std::endl;
}

// if valid, transit state to CLOSE, otherwise, print a warning message
void Context::close() {
    std::cout << "The current state is " << currentState << ", ";
    if (stateMap[currentState]["CLOSE"]) {
        currentState = "CLOSE";
        state = closeState;
        state -> close();
    }
    else std::cout << "this is not a valid operation, please refer to the state graph!" << std::endl;
}

// if valid, transit state to RUN, otherwise, print a warning message
void Context::run() {
    std::cout << "The current state is " << currentState << ", ";
    if (stateMap[currentState]["RUN"]) {
        currentState = "RUN";
        state = runState;
        state -> run();
    }
    else std::cout << "this is not a valid operation, please refer to the state graph!" << std::endl;
}

// if valid, transit state to STOP, otherwise, print a warning message
void Context::stop() {
    std::cout << "The current state is " << currentState << ", ";
    if (stateMap[currentState]["STOP"]) {
        currentState = "STOP";
        state = stopState;
        state -> stop();
    }
    else std::cout << "this is not a valid operation, please refer to the state graph!" << std::endl;
}

int main() {
    Context *context = new Context();
    context -> open();
    context -> close();
    context -> run();
    context -> stop();
    context -> open();

    delete context;
    return 0;
}